<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2006 Bradley Kite                                         |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

chdir('../../');

include ("./include/auth.php");
include_once($config["library_path"] . "/utility.php");
include_once($config["library_path"] . "/template.php");

$report_actions = array(
	1 => "Delete",
	2 => "Duplicate",
        3 => "Enable",
        4 => "Disable",
        5 => "Clear Reports"
	);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }

switch ($_REQUEST["action"]) {
	case 'save':
		form_save();
		break;
	case 'actions':
		form_actions();
		break;
	case 'report_edit':
		include_once($config["include_path"] . "/top_header.php");
		report_edit();
		include_once($config["include_path"] . "/bottom_footer.php");
		break;
	default:
		include_once($config["include_path"] . "/top_header.php");
		template();
		include_once($config["include_path"] . "/bottom_footer.php");
		break;
}

/* --------------------------
    The Save Function
   -------------------------- */

function form_save() {
		/* ================= input validation ================= */
		input_validate_input_number(get_request_var_post("id"));
		input_validate_input_number(get_request_var_post("data_template_id"));
		input_validate_input_number(get_request_var_post("graph_template_id"));
		input_validate_input_number(get_request_var_post("rra_id"));
		input_validate_input_number(get_request_var_post("include_data_from_start_hour"));
		input_validate_input_number(get_request_var_post("include_data_from_end_hour"));
		input_validate_input_number(get_request_var_post("include_data_from_start_day"));
		input_validate_input_number(get_request_var_post("include_data_from_end_day"));
		/* ==================================================== */

                if ($_POST["data_template_id"] == 0 && $_POST["graph_template_id"] == 0)
                {
                    raise_message(3);
                    $_SESSION["sess_error_fields"]["data_template_id"]  = 'data_template_id';
                    $_SESSION["sess_error_fields"]["graph_template_id"] = 'graph_template_id';
                }

                $report_definition["id"]                           = form_input_validate($_POST["id"], "id", "^[0-9]*$", false, 3);
                $report_definition["data_template_id"]             = form_input_validate($_POST["data_template_id"], "data_template_id", "^[0-9]*$", false, 3);
                $report_definition["graph_template_id"]            = form_input_validate($_POST["graph_template_id"], "graph_template_id", "^[0-9]*$", false, 3);
                $report_definition["rra_id"]                       = form_input_validate($_POST["rra_id"], "rra_id", "^[0-9]+$", false, 3);
                $report_definition["include_data_from_start_hour"] = form_input_validate($_POST["include_data_from_start_hour"], "include_data_from_start_hour", "^[0-9]+$", false, 3);
                $report_definition["include_data_from_end_hour"]   = form_input_validate($_POST["include_data_from_end_hour"], "include_data_from_end_hour", "^[0-9]+$", false, 3);
                $report_definition["include_data_from_start_day"]  = form_input_validate($_POST["include_data_from_start_day"], "include_data_from_start_day", "^[0-9]+$", false, 3);
                $report_definition["include_data_from_end_day"]    = form_input_validate($_POST["include_data_from_end_day"], "include_data_from_end_day", "^[0-9]+$", false, 3);
		$report_definition["report_name"]                  = form_input_validate($_POST["report_name"], "report_name", "", false, 3);

		if (!is_error_message()) {
			$id = sql_save($report_definition, "plugin_cactireport_definitions");

			if ($id) {
				raise_message(1);
			}else{
				raise_message(2);
			}
		}

		if ((is_error_message()))
                {
			header("Location: report_settings.php?action=report_edit&id=" . (empty($id) ? $_POST["id"] : $id));
		}else{
			header("Location: report_settings.php");
		}
}

/* ------------------------
    The "actions" function
   ------------------------ */

function form_actions() {
	global $colors, $report_actions;

	/* if we are to save this form, instead of display it */
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));

		if ($_POST["drp_action"] == "1") { /* delete */
			$report_definitions = db_fetch_assoc("select id from plugin_cactireport_definitions where " . array_to_sql_or($selected_items, "id"));

			if (sizeof($report_definitions) > 0) {
			foreach ($report_definitions as $report_definition) {
                                $reports = db_fetch_assoc("select id from plugin_cactireports where report_definition_id = " . $report_definition["id"]);
                                foreach ($reports as $report)
                                {
                                    db_execute("delete from plugin_cactireport_items where report_id = " . $report["id"]);
                                }
                                db_execute("delete from plugin_cactireports where report_definition_id = " . $report_definition["id"]);
				db_execute("delete from plugin_cactireport_definitions where id=" . $report_definition["id"]);
			}
			}

		}elseif ($_POST["drp_action"] == "2") { /* duplicate */
			for ($i=0;($i<count($selected_items));$i++) {
				/* ================= input validation ================= */
				input_validate_input_number($selected_items[$i]);
				/* ==================================================== */

                                $report = db_fetch_row("select * from plugin_cactireport_definitions where id = " . $selected_items[$i]);
                                $report["id"] = 0;
                                $report["report_name"] = str_replace("<report_name>", $report["report_name"], $_POST["report_name"]);
			        sql_save($report, "plugin_cactireport_definitions");
			}
		}
                elseif ($_POST["drp_action"] == "3") { /* Enable */
                    $report_definitions = db_fetch_assoc("select id from plugin_cactireport_definitions where " . array_to_sql_or($selected_items, "id"));
                    if (sizeof($report_definitions) > 0) {
                        foreach ($report_definitions as $report_definition) {
                                    db_execute("update plugin_cactireport_definitions set enabled = 'on' where id=" . $report_definition["id"]);
                        }
                    }
                }
                elseif ($_POST["drp_action"] == "4") { /* Disable */
                    $report_definitions = db_fetch_assoc("select id from plugin_cactireport_definitions where " . array_to_sql_or($selected_items, "id"));
                    if (sizeof($report_definitions) > 0) {
                        foreach ($report_definitions as $report_definition) {
                                    db_execute("update plugin_cactireport_definitions set enabled = 'off' where id=" . $report_definition["id"]);
                        }
                    }
                }
                elseif ($_POST["drp_action"] == "5") { /* Clear Reports */
			$report_definitions = db_fetch_assoc("select id from plugin_cactireport_definitions where " . array_to_sql_or($selected_items, "id"));

			if (sizeof($report_definitions) > 0) {
			foreach ($report_definitions as $report_definition) {
                                $reports = db_fetch_assoc("select id from plugin_cactireports where report_definition_id = " . $report_definition["id"]);
                                foreach ($reports as $report)
                                {
                                    db_execute("delete from plugin_cactireport_items where report_id = " . $report["id"]);
                                }
                                db_execute("delete from plugin_cactireports where report_definition_id = " . $report_definition["id"]);
			}
			}

		}


		header("Location: report_settings.php");
		exit;
	}

	/* setup some variables */
	$report_list = ""; $i = 0;

	/* loop through each of the graphs selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$report_list .= "<li>" . db_fetch_cell("select report_name from plugin_cactireport_definitions where id=" . $matches[1]) . "<br>";
			$report_array[$i] = $matches[1];
		}

		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $report_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='report_settings.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* delete */
		print "	<tr>
				<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>Are you sure you want to delete the following reports? Any data generated based on
					these reports will be lost.</p>
					<p>$report_list</p>
				</td>
			</tr>\n
			";
	}elseif ($_POST["drp_action"] == "2") { /* duplicate */
		print "	<tr>
				<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>When you click save, the following reports will be duplicated. You can
					optionally change the title format for the new data templates.</p>
					<p>$report_list</p>
					<p><strong>Title Format:</strong><br>"; form_text_box("report_name", "<report_name> (1)", "", "255", "30", "text"); print "</p>
				</td>
			</tr>\n
			";
	}
        elseif ($_POST["drp_action"] == "3") { /* Enable */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click save, the following reports will be Enabled.</p>
                                        <p>$report_list</p>
                                </td>
                        </tr>\n
                        ";
        }
        elseif ($_POST["drp_action"] == "4") { /* Disable */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click save, the following reports will be Disabled.</p>
                                        <p>$report_list</p>
                                </td>
                        </tr>\n
                        ";
        }
        elseif ($_POST["drp_action"] == "5") { /* Clear Reports */
                print " <tr>
                                <td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
                                        <p>When you click yes, the following reports will be have all of their reports cleared.</p>
                                        <p>$report_list</p>
                                        <p>Clearing a report deletes all the daily/weekly/monthly/yearly reports. </p>
                                </td>
                        </tr>\n
                        ";
        }

	if (!isset($report_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one report.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='../../images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print "	<tr>
			<td align='right' bgcolor='#eaeaea'>
				<input type='hidden' name='action' value='actions'>
				<input type='hidden' name='selected_items' value='" . (isset($report_array) ? serialize($report_array) : '') . "'>
				<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
				<a href='report_settings.php'><img src='../../images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
				$save_html
			</td>
		</tr>
		";

	html_end_box();

	include_once("./include/bottom_footer.php");
}

/* ----------------------------
    Report Editing
   ---------------------------- */

function report_edit() {
	global $colors, $struct_report_definition;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */

	if (!empty($_GET["id"])) {
		$report_definition = db_fetch_row("SELECT * FROM plugin_cactireport_definitions WHERE id=" . $_GET["id"]);

		$header_label = "[edit: " . $report_definition["report_name"] . "]";
	}else{
		$header_label = "[new]";
	}

	html_start_box("<strong>Report</strong> $header_label", "98%", $colors["header"], "3", "center", "");

	$form_array = array();

	while (list($field_name, $field_array) = each($struct_report_definition)) {
		$form_array += array($field_name => $struct_report_definition[$field_name]);

		$form_array[$field_name]["value"] = (isset($report_definition[$field_name]) ? $report_definition[$field_name] : "");
		$form_array[$field_name]["form_id"] = (isset($report_definition) ? $report_definition["id"] : "0");
	}

	draw_edit_form(
		array(
			"config" => array(
				),
			"fields" => inject_form_variables($form_array, (isset($report_definition) ? $report_definition : array()))
			)
		);

	html_end_box();

	form_save_button("report_settings.php");
}

function template() {
	global $colors, $report_actions;

	html_start_box("<strong>Reports</strong>", "98%", $colors["header"], "4", "center", "report_settings.php?action=report_edit");

	html_header_checkbox(array("Report Name", "Data Template", "Graph Template", "RRA", "Enabled"));

	$template_list = db_fetch_assoc("SELECT
					plugin_cactireport_definitions.id,
					plugin_cactireport_definitions.report_name,
					data_template.name as data_template_name,
					graph_templates.name as graph_template_name,
					rra.name as rra_name,
					plugin_cactireport_definitions.enabled
					FROM (plugin_cactireport_definitions)
					LEFT JOIN graph_templates ON (plugin_cactireport_definitions.graph_template_id = graph_templates.id)
					LEFT JOIN data_template ON (plugin_cactireport_definitions.data_template_id = data_template.id)
					LEFT JOIN rra ON (plugin_cactireport_definitions.rra_id = rra.id)
					ORDER BY plugin_cactireport_definitions.report_name");
	$i = 0;
	if (sizeof($template_list) > 0) {
	foreach ($template_list as $template) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i);
			?>
			<td>
				<a class="linkEditMain" href="report_settings.php?action=report_edit&id=<?php print $template["id"];?>"><?php print $template["report_name"];?></a>
			</td>
			<td>
				<?php print (empty($template["data_template_name"]) ? "<em>None</em>": $template["data_template_name"]);?>
			</td>
			<td>
				<?php print (empty($template["graph_template_name"]) ? "<em>None</em>": $template["graph_template_name"]);?>
			</td>
			<td>
				<?php print (empty($template["rra_name"]) ? "<em>None</em>": $template["rra_name"]);?>
			</td>
			<td>
				<?php print (empty($template["enabled"]) ? "<em>None</em>": $template["enabled"]);?>
			</td>
			<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
				<input type='checkbox' style='margin: 0px;' name='chk_<?php print $template["id"];?>' title="<?php print $template["report_name"];?>">
			</td>
		</tr>
		<?php
		$i++;
	}
	}else{
		print "<tr><td><em>No Reports</em></td></tr>\n";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	draw_actions_dropdown($report_actions);

	print "</form>\n";
}

?>
